unit UnidadMenuPrincipal;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, shlobj, ExtCtrls, shellapi, ComCtrls, Grids, activex,
  comobj;
//Historial
const
  STATURL_QUERYFLAG_ISCACHED = $00010000;
  STATURL_QUERYFLAG_NOURL = $00020000;
  STATURL_QUERYFLAG_NOTITLE = $00040000;
  STATURL_QUERYFLAG_TOPLEVEL = $00080000;

  STATURLFLAG_ISCACHED = $00000001;
  STATURLFLAG_ISTOPLEVEL = $00000002;

  IID_IEnumStatUrl: TGUID = (D1: $3C374A42; D2: $BAE4; D3: $11CF; D4: ($BF, $7D, $00, $AA, $00, $69, $46, $EE));
  IID_IUrlHistoryStg: TGUID = (D1: $3C374A41; D2: $BAE4; D3: $11CF; D4: ($BF, $7D, $00, $AA, $00, $69, $46, $EE));
  IID_IUrlHistoryStg2: TGUID = (D1: $AFA0DC11; D2: $C313; D3: $831A; D4: ($83, $1A, $00, $C0, $4F, $D5, $AE, $38));
  IID_IUrlHistoryNotify: TGUID = (D1: $BC40BEC1; D2: $C493; D3: $11D0; D4: ($83, $1B, $00, $C0, $4F, $D5, $AE, $38));

  SID_IEnumStatUrl = '{3C374A42-BAE4-11CF-BF7D-00AA006946EE}';
  SID_IUrlHistoryStg = '{3C374A41-BAE4-11CF-BF7D-00AA006946EE}';
  SID_IUrlHistoryStg2 = '{AFA0DC11-C313-11d0-831A-00C04FD5AE38}';
  SID_IURLHistoryNotify = '{BC40BEC1-C493-11d0-831B-00C04FD5AE38}';
  CLSID_CUrlHistory: TGUID = '{3C374A40-BAE4-11CF-BF7D-00AA006946EE}';

type
  STATURL = record
    cbSize: DWORD;
    pwcsUrl: DWORD;
    pwcsTitle: DWORD;
    ftLastVisited: FILETIME;
    ftLastUpdated: FILETIME;
    ftExpires: FILETIME;
    dwFlags: DWORD;
  end;

  IEnumSTATURL = interface(IUnknown)
  ['{3C374A42-BAE4-11CF-BF7D-00AA006946EE}']
  function Next(celt: Integer; out elt; pceltFetched: PLongint): HRESULT; stdcall;
  function Skip(celt: Longint): HRESULT; stdcall;
  function Reset: HResult; stdcall;
  function Clone(out ppenum: IEnumSTATURL): HResult; stdcall;
  function SetFilter(poszFilter: PWideChar; dwFlags: DWORD): HResult; stdcall;
end;

  IUrlHistoryStg = interface(IUnknown)
    ['{3C374A41-BAE4-11CF-BF7D-00AA006946EE}']
    function AddUrl(pocsUrl: PWideChar; pocsTitle: PWideChar; dwFlags: Integer): HResult; stdcall;
    function DeleteUrl(pocsUrl: PWideChar; dwFlags: Integer): HResult; stdcall;
    function QueryUrl(pocsUrl: PWideChar; dwFlags: Integer; var lpSTATURL: STATURL): HResult; stdcall;
    function BindToObject(pocsUrl: PWideChar; var riid: TIID; out ppvOut: Pointer): HResult; stdcall;
    function EnumUrls(out ppenum: IEnumSTATURL): HResult; stdcall;
  end;

  IUrlHistoryStg2 = interface(IUrlHistoryStg)
    ['{AFA0DC11-C313-11D0-831A-00C04FD5AE38}']
    function AddUrlAndNotify(pocsUrl: PWideChar; pocsTitle: PWideChar; dwFlags: Integer;
    fWriteHistory: Integer; var poctNotify: Pointer;
    const punkISFolder: IUnknown): HResult; stdcall;
    function ClearHistory: HResult; stdcall;
  end;

  IUrlHistoryNotify = interface(IOleCommandTarget)
    ['{BC40BEC1-C493-11d0-831B-00C04FD5AE38}']
  end;

//fin historial

type
  TformMenuPrincipal = class(TForm)
    SaveDialog1: TSaveDialog;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    TabSheet2: TTabSheet;
    TabSheet3: TTabSheet;
    Panel1: TPanel;
    mCarpetas: TMemo;
    Panel2: TPanel;
    bObtener: TButton;
    bGuardar: TButton;
    LWEB: TLabel;
    bCerrar: TButton;
    lCookies: TListBox;
    Panel3: TPanel;
    bObtenerCookies: TButton;
    bEliminar: TButton;
    bGuardarCookies: TButton;
    Panel4: TPanel;
    bObtenerEscritorio: TButton;
    bEliminarEscritorio: TButton;
    bGuardarEscritorio: TButton;
    lEscritorio: TListBox;
    TabSheet4: TTabSheet;
    lMenuProgramas: TListBox;
    Panel5: TPanel;
    bObtenerMenuProgramas: TButton;
    bEliminarMenuProgramas: TButton;
    bGuardarMenuProgramas: TButton;
    TabSheet5: TTabSheet;
    lInicio: TListBox;
    Panel6: TPanel;
    bObtenerInicio: TButton;
    bEliminarInicio: TButton;
    bGuardarInicio: TButton;
    TabSheet6: TTabSheet;
    Panel7: TPanel;
    bObtenerRecientes: TButton;
    bEliminarRecientes: TButton;
    bGuardarRecientes: TButton;
    lRecientes: TListBox;
    TabSheet7: TTabSheet;
    Panel8: TPanel;
    bHistorial: TButton;
    bGuardarHistorial: TButton;
    TabSheet9: TTabSheet;
    Panel10: TPanel;
    bObtenerDatosPrograma: TButton;
    bEliminarDatosPrograma: TButton;
    bGuardarDatosPrograma: TButton;
    lDatosPrograma: TListBox;
    TabSheet10: TTabSheet;
    lFavoritos: TListBox;
    Panel11: TPanel;
    bObtenerFavoritos: TButton;
    bEliminarFavoritos: TButton;
    bGuardarFavoritos: TButton;
    StringGrid1: TStringGrid;
    procedure bObtenerClick(Sender: TObject);
    procedure bGuardarClick(Sender: TObject);
    procedure bCerrarClick(Sender: TObject);
    procedure LWEBClick2(Sender: TObject);
    procedure bObtenerCookiesClick(Sender: TObject);
    procedure bEliminarClick(Sender: TObject);
    procedure bGuardarCookiesClick(Sender: TObject);
    procedure bObtenerEscritorioClick(Sender: TObject);
    procedure bEliminarEscritorioClick(Sender: TObject);
    procedure bGuardarEscritorioClick(Sender: TObject);
    procedure bObtenerMenuProgramasClick(Sender: TObject);
    procedure bGuardarMenuProgramasClick(Sender: TObject);
    procedure bEliminarMenuProgramasClick(Sender: TObject);
    procedure bObtenerInicioClick(Sender: TObject);
    procedure bGuardarInicioClick(Sender: TObject);
    procedure bEliminarInicioClick(Sender: TObject);
    procedure bObtenerRecientesClick(Sender: TObject);
    procedure bGuardarRecientesClick(Sender: TObject);
    procedure bEliminarRecientesClick(Sender: TObject);
    procedure bHistorialClick(Sender: TObject);
    procedure bObtenerDatosProgramaClick(Sender: TObject);
    procedure bGuardarDatosProgramaClick(Sender: TObject);
    procedure bEliminarDatosProgramaClick(Sender: TObject);
    procedure bObtenerFavoritosClick(Sender: TObject);
    procedure bGuardarFavoritosClick(Sender: TObject);
    procedure bEliminarFavoritosClick(Sender: TObject);
    procedure bGuardarHistorialClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  formMenuPrincipal: TformMenuPrincipal;
  procedure obtenerSubcarpetas(Folder:string; sList:TStringList);

implementation

var
  resultadoB : TStringList;

  //para historial
  I: IUrlHistoryStg2;


  {$R *.dfm}

//para historial
function FileTimeToDt(Ft: TFileTime): TDateTime;
var
  l: Integer;
  lft: TFileTime;
begin
  FileTimeToLocalFiletime(Ft, lft);
  if FileTimeToDosDateTime(lft, Longrec(l).Hi, Longrec(l).Lo) then
    result := FiledateToDatetime(l)
  else
    result := 0;
end;

procedure buscarFicheros (filtro, carpeta : string; Recursiva : boolean);
var
  sr : TSearchRec;
  sListaCarpetas : TStringList;
  i : integer;
begin
  if FindFirst(carpeta + Filtro, faAnyFile, sr) = 0 then
  begin
    repeat
      if (sr.Name <> '.') and (sr.Name <> '..') then
        resultadoB.Add (carpeta + sr.Name);
    until FindNext(sr) <> 0;
  end;
  FindClose(sr);
  if Recursiva then
  begin
    sListaCarpetas := TStringList.Create;
    try
      obtenerSubcarpetas(carpeta, sListaCarpetas);
      for i := 0 to sListaCarpetas.Count - 1 do
      begin
        if (sListaCarpetas[i] <> '.') and (sListaCarpetas[i] <> '..') then
        begin
          Application.ProcessMessages;
          buscarFicheros(filtro, IncludeTrailingPathDelimiter(carpeta +
              sListaCarpetas[i]), Recursiva);
        end;
      end;
    finally
      sListaCarpetas.Free;
    end;
  end;
end;

procedure obtenerSubcarpetas(Folder:string; sList:TStringList);
 var
  sr:TSearchRec;
begin
  if FindFirst(Folder+'*.*',faDirectory,sr)=0 then
   try
    repeat
      if(sr.Attr and faDirectory)=faDirectory then
       sList.Add(sr.Name);
    until FindNext(sr)<>0;
   finally
    FindClose(sr);
   end;
end;


function obtenerCarpeta (Folder: Integer): String;
var
  FilePath : array[0..MAX_PATH] of char;
begin
  SHGetSpecialFolderPath(0, FilePath, Folder , False);
  Result := FilePath;
end;

procedure TformMenuPrincipal.bObtenerClick(Sender: TObject);
begin
  mCarpetas.Clear;
  mCarpetas.Lines.Add('Cookies: ' + obtenerCarpeta (CSIDL_COOKIES));
  mCarpetas.Lines.Add('Escritorio: ' + obtenerCarpeta (CSIDL_DESKTOP));
  mCarpetas.Lines.Add('Programas del men Inicio: ' + obtenerCarpeta (CSIDL_PROGRAMS));
  mCarpetas.Lines.Add('Impresoras: ' + obtenerCarpeta (CSIDL_PRINTERS));
  mCarpetas.Lines.Add('Mis documentos: ' + obtenerCarpeta (CSIDL_PERSONAL));
  mCarpetas.Lines.Add('Favoritos: ' + obtenerCarpeta (CSIDL_FAVORITES));
  mCarpetas.Lines.Add('Inicio del men Programas: ' + obtenerCarpeta (CSIDL_STARTUP));
  mCarpetas.Lines.Add('Documentos recientes: ' + obtenerCarpeta (CSIDL_RECENT));
  mCarpetas.Lines.Add('Enviar a: ' + obtenerCarpeta (CSIDL_SENDTO));
  mCarpetas.Lines.Add('Men Inicio: ' + obtenerCarpeta (CSIDL_STARTMENU));
  mCarpetas.Lines.Add('Escritorio (carpeta): ' + obtenerCarpeta (CSIDL_DESKTOPDIRECTORY));
  mCarpetas.Lines.Add('Entorno de red: ' + obtenerCarpeta (CSIDL_NETHOOD));
  mCarpetas.Lines.Add('Fuentes: ' + obtenerCarpeta (CSIDL_FONTS));
  mCarpetas.Lines.Add('Plantillas: ' + obtenerCarpeta (CSIDL_TEMPLATES));
  mCarpetas.Lines.Add('Men Inicio de todos los usuarios: ' + obtenerCarpeta (CSIDL_COMMON_STARTMENU));
  mCarpetas.Lines.Add('Programas del men Inicio de todos los usuarios: ' + obtenerCarpeta (CSIDL_COMMON_PROGRAMS));
  mCarpetas.Lines.Add('Carpeta Inicio del men Programas de todos los usuarios: ' + obtenerCarpeta (CSIDL_COMMON_STARTUP));
  mCarpetas.Lines.Add('Escritorio de todos los usuarios: ' + obtenerCarpeta (CSIDL_COMMON_DESKTOPDIRECTORY));
  mCarpetas.Lines.Add('Favoritos de todos los usuarios: ' + obtenerCarpeta (CSIDL_COMMON_FAVORITES));
  mCarpetas.Lines.Add('Datos de los programas: ' + obtenerCarpeta (CSIDL_APPDATA));
  mCarpetas.Lines.Add('Archivos temporales de Internet: ' + obtenerCarpeta (CSIDL_INTERNET_CACHE));
  mCarpetas.Lines.Add('Historial: ' + obtenerCarpeta (CSIDL_HISTORY));
end;

procedure TformMenuPrincipal.bGuardarClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Guardar carpetas del sistema...';
  SaveDialog1.FileName := 'Carpetas';
  if SaveDialog1.Execute then
    mCarpetas.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TformMenuPrincipal.bCerrarClick(Sender: TObject);
begin
  close;
end;

procedure TformMenuPrincipal.LWEBClick2(Sender: TObject);
begin
  ShellExecute(Handle, Nil, PChar(LWEB.CAPTION),
      Nil, Nil, SW_SHOWNORMAL);
end;

procedure TformMenuPrincipal.bObtenerCookiesClick(Sender: TObject);
var
  ruta : String;
begin
  lCookies.Clear;
  ruta := obtenerCarpeta(CSIDL_COOKIES);
  resultadoB := TStringList.Create;
  buscarFicheros('*.*', ruta + '\',true);
  lCookies.Items.AddStrings(resultadoB);
  resultadoB.Free;
end;

procedure TformMenuPrincipal.bEliminarClick(Sender: TObject);
begin
  if lCookies.ItemIndex = -1 then
    MessageDlg('Debe seleccionar la Cookie a eliminar.', mtInformation, [mbok], 0)
  else
  begin
    if MessageDlg('Desea eliminar la cookie [' +
        ExtractFileName(lCookies.Items[lCookies.ItemIndex]) + ']?',
        mtConfirmation, [mbyes, mbno], 0) = mryes then
    begin
      if DeleteFile(lCookies.Items[lCookies.ItemIndex]) then
        bObtenerCookiesClick(nil)
      else
        MessageDlg('La Cookie [' +
            ExtractFileName(lCookies.Items[lCookies.ItemIndex]) +
            '] no se ha podido eliminar. Puede que est abierto.', mtWarning, [mbok], 0);
    end;
  end;
end;

procedure TformMenuPrincipal.bGuardarCookiesClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Guardar ficheros de Cookies...';
  SaveDialog1.FileName := 'Cookies';
  if SaveDialog1.Execute then
    lCookies.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TformMenuPrincipal.bObtenerEscritorioClick(Sender: TObject);
var
  ruta : String;
begin
  lEscritorio.Clear;
  ruta := obtenerCarpeta(CSIDL_DESKTOP);
  resultadoB := TStringList.Create;
  buscarFicheros('*.*', ruta + '\',true);
  lEscritorio.Items.AddStrings(resultadoB);
  resultadoB.Free;
end;

procedure TformMenuPrincipal.bEliminarEscritorioClick(Sender: TObject);
begin
  if lEscritorio.ItemIndex = -1 then
    MessageDlg('Debe seleccionar el Fichero a eliminar.', mtInformation, [mbok], 0)
  else
  begin
    if MessageDlg('Desea eliminar el fichero [' +
        ExtractFileName(lEscritorio.Items[lEscritorio.ItemIndex]) + ']?',
        mtConfirmation, [mbyes, mbno], 0) = mryes then
    begin
      if DeleteFile(lEscritorio.Items[lEscritorio.ItemIndex]) then
        bObtenerEscritorioClick(nil)
      else
        MessageDlg('El fichero [' +
            ExtractFileName(lEscritorio.Items[lEscritorio.ItemIndex]) +
            '] no se ha podido eliminar. Puede que sea una carpeta o que est abierto.', mtWarning, [mbok], 0);
    end;
  end;
end;

procedure TformMenuPrincipal.bGuardarEscritorioClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Guardar ficheros del Escritorio...';
  SaveDialog1.FileName := 'Escritorio';
  if SaveDialog1.Execute then
    lEscritorio.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TformMenuPrincipal.bObtenerMenuProgramasClick(Sender: TObject);
var
  ruta : String;
begin
  lMenuProgramas.Clear;
  ruta := obtenerCarpeta(CSIDL_PROGRAMS);
  resultadoB := TStringList.Create;
  buscarFicheros('*.*', ruta + '\',true);
  lMenuProgramas.Items.AddStrings(resultadoB);
  resultadoB.Free;
end;

procedure TformMenuPrincipal.bGuardarMenuProgramasClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Guardar ficheros de Programas del Men Inicio...';
  SaveDialog1.FileName := 'Men Inicio';
  if SaveDialog1.Execute then
    lMenuProgramas.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TformMenuPrincipal.bEliminarMenuProgramasClick(Sender: TObject);
begin
  if lMenuProgramas.ItemIndex = -1 then
    MessageDlg('Debe seleccionar el Fichero a eliminar.', mtInformation, [mbok], 0)
  else
  begin
    if MessageDlg('Desea eliminar el fichero [' +
        ExtractFileName(lMenuProgramas.Items[lMenuProgramas.ItemIndex]) + ']?',
        mtConfirmation, [mbyes, mbno], 0) = mryes then
    begin
      if DeleteFile(lMenuProgramas.Items[lMenuProgramas.ItemIndex]) then
        bObtenerMenuProgramasClick(nil)
      else
        MessageDlg('El fichero [' +
            ExtractFileName(lMenuProgramas.Items[lMenuProgramas.ItemIndex]) +
            '] no se ha podido eliminar. Puede que sea una carpeta o que est abierto.', mtWarning, [mbok], 0);
    end;
  end;
end;

procedure TformMenuPrincipal.bObtenerInicioClick(Sender: TObject);
var
  ruta : String;
begin
  lInicio.Clear;
  //inicio del usuario actual
  ruta := obtenerCarpeta(CSIDL_STARTUP);
  resultadoB := TStringList.Create;
  buscarFicheros('*.*', ruta + '\',true);
  ruta := obtenerCarpeta(CSIDL_COMMON_STARTUP);
  buscarFicheros('*.*', ruta + '\',true);
  lInicio.Items.AddStrings(resultadoB);
  resultadoB.Free;
end;

procedure TformMenuPrincipal.bGuardarInicioClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Guardar accesos directos de la carpeta Inicio...';
  SaveDialog1.FileName := 'Carpeta Inicio';
  if SaveDialog1.Execute then
    lInicio.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TformMenuPrincipal.bEliminarInicioClick(Sender: TObject);
begin
  if lInicio.ItemIndex = -1 then
    MessageDlg('Debe seleccionar el Fichero a eliminar.', mtInformation, [mbok], 0)
  else
  begin
    if MessageDlg('Desea eliminar el fichero [' +
        ExtractFileName(lInicio.Items[lInicio.ItemIndex]) + ']?',
        mtConfirmation, [mbyes, mbno], 0) = mryes then
    begin
      if DeleteFile(lInicio.Items[lInicio.ItemIndex]) then
        bObtenerInicioClick(nil)
      else
        MessageDlg('El fichero [' +
            ExtractFileName(lInicio.Items[lInicio.ItemIndex]) +
            '] no se ha podido eliminar. Puede que sea una carpeta o que est abierto.', mtWarning, [mbok], 0);
    end;
  end;
end;

procedure TformMenuPrincipal.bObtenerRecientesClick(Sender: TObject);
var
  ruta : String;
begin
  lRecientes.Clear;
  ruta := obtenerCarpeta(CSIDL_RECENT);
  resultadoB := TStringList.Create;
  buscarFicheros('*.*', ruta + '\',true);
  lRecientes.Items.AddStrings(resultadoB);
  resultadoB.Free;
end;

procedure TformMenuPrincipal.bGuardarRecientesClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Guardar accesos directos de Documentos recientes...';
  SaveDialog1.FileName := 'Documentos recientes';
  if SaveDialog1.Execute then
    lRecientes.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TformMenuPrincipal.bEliminarRecientesClick(Sender: TObject);
begin
  if lRecientes.ItemIndex = -1 then
    MessageDlg('Debe seleccionar el acceso directo a eliminar.', mtInformation, [mbok], 0)
  else
  begin
    if MessageDlg('Desea eliminar el acceso directo [' +
        ExtractFileName(lRecientes.Items[lRecientes.ItemIndex]) + ']?',
        mtConfirmation, [mbyes, mbno], 0) = mryes then
    begin
      if DeleteFile(lRecientes.Items[lRecientes.ItemIndex]) then
        bObtenerRecientesClick(nil)
      else
        MessageDlg('El acceso directo [' +
            ExtractFileName(lRecientes.Items[lRecientes.ItemIndex]) +
            '] no se ha podido eliminar. Puede que sea una carpeta o que est abierto.', mtWarning, [mbok], 0);
    end;
  end;
end;

procedure TformMenuPrincipal.bHistorialClick(Sender: TObject);
var
  r: Staturl;
  Enum: IEnumStatUrl;
  X: Integer;
  Row: Integer;
begin
  StringGrid1.Cells[0, 0] := 'ltima visita';
  StringGrid1.Cells[1, 0] := 'Ttulo';
  StringGrid1.Cells[2, 0] := 'Direccin';
  StringGrid1.Cells[3, 0] := 'ltima actualizacin';
  StringGrid1.Cells[4, 0] := 'Expira';
  Row := 0;
  I := CreateComObject(ClsId_CUrlHistory) as IUrlHistoryStg2;
  I.EnumUrls(Enum);
  Enum.SetFilter('http://', 0);
  while enum.next(1, r, @X) = S_OK do
  begin
    Inc(Row);
    StringGrid1.RowCount := Row + 1;
    Stringgrid1.Cells[0, Row] := DateTimeToStr(FileTimeToDt(r.ftLastVisited));
    Stringgrid1.Cells[1, Row] := PWidechar(Pointer(r.pwcsTitle));
    Stringgrid1.Cells[2, Row] := PWidechar(Pointer(r.pwcsUrl));
    Stringgrid1.Cells[3, Row] := DateTimeToStr(FileTimeToDt(r.ftLastUpdated));
    Stringgrid1.Cells[4, Row] := DateTimeToStr(FileTimeToDt(r.ftExpires));
  end;
end;

procedure TformMenuPrincipal.bObtenerDatosProgramaClick(Sender: TObject);
var
  ruta : String;
begin
  lDatosPrograma.Clear;
  ruta := obtenerCarpeta(CSIDL_APPDATA);
  resultadoB := TStringList.Create;
  buscarFicheros('*.*', ruta + '\',true);
  lDatosPrograma.Items.AddStrings(resultadoB);
  resultadoB.Free;
end;

procedure TformMenuPrincipal.bGuardarDatosProgramaClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Guardar Datos de Programa...';
  SaveDialog1.FileName := 'Datos de Programa';
  if SaveDialog1.Execute then
    lDatosPrograma.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TformMenuPrincipal.bEliminarDatosProgramaClick(Sender: TObject);
begin
  if lDatosPrograma.ItemIndex = -1 then
    MessageDlg('Debe seleccionar el fichero a eliminar.', mtInformation, [mbok], 0)
  else
  begin
    if MessageDlg('Desea eliminar el fichero [' +
        ExtractFileName(lDatosPrograma.Items[lDatosPrograma.ItemIndex]) + ']?',
        mtConfirmation, [mbyes, mbno], 0) = mryes then
    begin
      if DeleteFile(lDatosPrograma.Items[lDatosPrograma.ItemIndex]) then
        bObtenerDatosProgramaClick(nil)
      else
        MessageDlg('El fichero [' +
            ExtractFileName(lDatosPrograma.Items[lDatosPrograma.ItemIndex]) +
            '] no se ha podido eliminar. Puede que sea una carpeta o que est abierto.', mtWarning, [mbok], 0);
    end;
  end;
end;

procedure TformMenuPrincipal.bObtenerFavoritosClick(Sender: TObject);
var
  ruta : String;
begin
  lFavoritos.Clear;
  ruta := obtenerCarpeta(CSIDL_FAVORITES);
  resultadoB := TStringList.Create;
  buscarFicheros('*.*', ruta + '\',true);
  lFavoritos.Items.AddStrings(resultadoB);
  resultadoB.Free;
end;

procedure TformMenuPrincipal.bGuardarFavoritosClick(Sender: TObject);
begin
  SaveDialog1.Title := 'Guardar Favoritos...';
  SaveDialog1.FileName := 'Favoritos';
  if SaveDialog1.Execute then
    lFavoritos.Items.SaveToFile(SaveDialog1.FileName);
end;

procedure TformMenuPrincipal.bEliminarFavoritosClick(Sender: TObject);
begin
  if lFavoritos.ItemIndex = -1 then
    MessageDlg('Debe seleccionar el fichero a eliminar.', mtInformation, [mbok], 0)
  else
  begin
    if MessageDlg('Desea eliminar el fichero [' +
        ExtractFileName(lFavoritos.Items[lFavoritos.ItemIndex]) + ']?',
        mtConfirmation, [mbyes, mbno], 0) = mryes then
    begin
      if DeleteFile(lFavoritos.Items[lFavoritos.ItemIndex]) then
        bObtenerFavoritosClick(nil)
      else
        MessageDlg('El fichero [' +
            ExtractFileName(lFavoritos.Items[lFavoritos.ItemIndex]) +
            '] no se ha podido eliminar. Puede que sea una carpeta o que est abierto.', mtWarning, [mbok], 0);
    end;
  end;
end;

procedure TformMenuPrincipal.bGuardarHistorialClick(Sender: TObject);
const
   CHAR_SEP = '|';
 var
   f, i , j : Integer;
   Str : String;
   TS : TStrings;
begin
  SaveDialog1.Title := 'Guardar Historial de Internet...';
  SaveDialog1.FileName := 'Historial';
  if SaveDialog1.Execute then
  begin
    Str := '';
    TS := TStringList.Create();
    for f := 1 to StringGrid1.RowCount - 1 do
    begin
      StringGrid1.Row := f;
      Str := '';
      // Para cada lnea de las selecciondas
      for i := (StringGrid1.Selection.Top) to (StringGrid1.Selection.Bottom) do
      begin
        // Si no es la 1 linea, aadimos un salto de lnea
        if (i <> StringGrid1.Selection.Top) then begin
          Str := Str + #13#10;
        end;
        // Para cada elemento dentro de la lnea (celdas)...
        for j := 0 to (StringGrid1.Rows[i].Count - 1) do begin
          // Si no es la primera celda, aadimos un separador
          if (j <> 0) then begin
            Str := Str + CHAR_SEP;
          end;
          // Construimos la cadena
          Str := Str + StringGrid1.Rows[i].Strings[j];
        end;
        // La guardamos en el fichero (utilizando un TStrings, por ejemplo)
      end;
      TS.Add(Str);      
    end;
    TS.SaveToFile(SaveDialog1.FileName);
    TS.Free;
  end;
end;

end.
